// src/index.ts
import {
  delimitedIndent,
  foldInside,
  foldNodeProp,
  indentNodeProp,
  LanguageSupport,
  LRLanguage
} from "@codemirror/language";
import { styleTags, tags as t } from "@lezer/highlight";

// esbuild-plugin-lezer:/Users/nvie/Projects/liveblocks/liveblocks-schema/packages/codemirror-language/src/syntax.grammar
import { LRParser } from "@lezer/lr";
var spec_name = { __proto__: null, type: 10 };
var parser = LRParser.deserialize({
  version: 14,
  states: "'bO]QPOOObQQO'#C_Q]QPOOOOQO'#C`'#C`OOQO'#Cr'#CrOOQO'#Cb'#CbOgQPO,58yOOQO-E6p-E6pOoQPO'#DOOOQO'#Cc'#CcOOQO1G.e1G.eOtQPO1G.eOOQO'#Cf'#CfOyQPO'#CeOOQO'#Cs'#CsO!RQPO,59jOOQO7+$P7+$PO!ZQPO,59PO!lQPO,59POOQO-E6q-E6qOOQO1G/U1G/UOOQO'#Ci'#CiO!qQPO'#ChOOQO'#Cn'#CnOOQO'#Co'#CoOOQO'#Ch'#ChO#VQPO'#DQO#eQPO1G.kO!ZQPO1G.kO!ZQPO,59VOOQO'#Cu'#CuO#pQPO,59XO!ZQPO'#CvO$RQPO,59lOOQO7+$V7+$VO$aQPO7+$VO$lQQO'#DRO$tQQO'#ChO%SQPO1G.qOOQO-E6s-E6sOOQO,59b,59bOOQO-E6t-E6tOOQO<<Gq<<GqO!ZQPO'#CtO%XQQO,59mO%aQQO,59XOOQO7+$]7+$]OOQO,59`,59`OOQO-E6r-E6r",
  stateData: "%l~OmOSnOSPOS~OTRO~OpTO~OWWOqZO~Oo[O~OWWO~OZaOsbO~OedOo[O~OWWOoeOxgOyhOzhO~OZlO~O`mOwnOd[Xe[Xo[X{[X~OdpOetXotX{tX~O{rOeXioXi~OwnOdaaeaaoaa{aa~OdpOetaota{ta~O{zOeXqoXq~Ov{O^uX~O`mOwnO^[Xv[X~O^!OO~Ov{O^ua~OwnO^aavaa~O",
  goto: "$VvPPPw{P!P!SP!a!eP!i!vP!YP!Y!Y!YPP#P#V#]#c#mPPPPPPP#sP#|$STSOQTPOQRUPQYUQ`ZZialmp{T^W_T]W_SjalQtmQxpR!P{UfalpTum{QQORVQQ_WRc_Q|tR!Q|QofSwo}R}uQqjRyq_XUZalmp{QkaRslRvm",
  nodeNames: "\u26A0 Comment Document ObjectTypeDefinition TypeKeyword type NamedTypeDeclaration FieldsDefinition { ValueDefinition ValueName : Type NamedType > GenericType < ArrayType Number String | }",
  maxTerm: 43,
  skippedNodes: [0, 1],
  repeatNodeCount: 5,
  tokenData: "+S~RpX^#Vpq#Vrs#zst%twx&]xy(Vyz(V|}([}!O(c!P!Q(|!Q![(i![!])S!]!^)X!^!_)^!_!`)c!`!a)h!a!b)m!c!})r!}#O*V#R#S)r#T#o*b#o#p*s#p#q*x#q#r*}#y#z#V$f$g#V#BY#BZ#V$IS$I_#V$I|$JO#V$JT$JU#V$KV$KW#V&FU&FV#V~#[Ym~X^#Vpq#V#y#z#V$f$g#V#BY#BZ#V$IS$I_#V$I|$JO#V$JT$JU#V$KV$KW#V&FU&FV#V~#}XOY#zYZ$jZr#zrs$js#O#z#O#P$o#P;'S#z;'S;=`%n<%lO#z~$oOy~~$rRO;'S#z;'S;=`${;=`O#z~%OYOY#zYZ$jZr#zrs$js#O#z#O#P$o#P;'S#z;'S;=`%n;=`<%l#z<%lO#z~%qP;=`<%l#z~%ySP~OY%tZ;'S%t;'S;=`&V<%lO%t~&YP;=`<%l%t~&`XOY&]YZ&{Zw&]wx&{x#O&]#O#P'Q#P;'S&];'S;=`(P<%lO&]~'QOz~~'TRO;'S&];'S;=`'^;=`O&]~'aYOY&]YZ&{Zw&]wx&{x#O&]#O#P'Q#P;'S&];'S;=`(P;=`<%l&]<%lO&]~(SP;=`<%l&]~([On~R(cOvQ{P~(fP!Q![(i~(nQx~!O!P(t!Q![(i~(yPx~!Q![(t~)PP!P!Q%t~)XOZ~P)^O{P~)cO`~~)hOq~~)mO^~~)rOs~R)ySpQoP!Q![)r!c!})r#R#S)r#T#o)r~*YP#P#Q*]~*bOw~P*gSoP!Q![*b!c!}*b#R#S*b#T#o*b~*xOW~~*}Od~~+SOe~",
  tokenizers: [0, 1],
  topRules: { "Document": [0, 2] },
  specialized: [{ term: 31, get: (value) => spec_name[value] || -1 }],
  tokenPrec: 0
});

// src/linter.ts
import { linter as lint } from "@codemirror/lint";
import { getDiagnostics } from "@liveblocks/schema";
var linter = lint(
  (view) => {
    const code = view.state.doc.toString();
    const diagnostics = getDiagnostics(code).map((diagnostic) => {
      var _a;
      return {
        from: diagnostic.range[0].offset,
        to: diagnostic.range[1].offset,
        message: diagnostic.message,
        severity: diagnostic.severity,
        actions: (_a = diagnostic.suggestions) == null ? void 0 : _a.map((suggestion) => {
          if (suggestion.type === "replace") {
            return {
              name: "Replace",
              apply: (view2, from, to) => {
                view2.dispatch({
                  changes: { from, to, insert: suggestion.name }
                });
              }
            };
          } else if (suggestion.type === "add-object-type-def") {
            return {
              name: "Add definition",
              apply: (view2) => {
                const insert = `

type ${suggestion.name} {
  
}
`;
                const to = code.length;
                const from = code.trimEnd().length;
                view2.dispatch({
                  changes: {
                    from: to,
                    insert
                  },
                  selection: { anchor: from + insert.length - 3 }
                });
              }
            };
          } else if (suggestion.type === "remove") {
            return {
              name: "Remove",
              apply: (view2) => {
                view2.dispatch({
                  changes: {
                    from: suggestion.range[0],
                    to: suggestion.range[1]
                  }
                });
              }
            };
          } else {
            return;
          }
        }).filter(Boolean)
      };
    });
    return diagnostics;
  },
  { delay: 200 }
);

// src/index.ts
var parentheses = "( )";
var braces = "{ }";
var angleBrackets = "< >";
var punctuations = `${parentheses} ${braces} ${angleBrackets} : = ? |`;
var blocks = `FieldsDefinition ${braces}`;
var generic = `GenericType ${angleBrackets}`;
var LiveblocksSchema = LRLanguage.define({
  name: "liveblocks-schema",
  parser: parser.configure({
    props: [
      indentNodeProp.add({
        [blocks]: delimitedIndent({ closing: "}", align: true })
      }),
      indentNodeProp.add({
        [generic]: delimitedIndent({ closing: ">", align: false })
      }),
      foldNodeProp.add({
        [blocks]: foldInside
      }),
      styleTags({
        Comment: t.lineComment,
        ValueName: t.name,
        NamedType: t.typeName,
        GenericType: t.special(t.typeName),
        NamedTypeDeclaration: t.function(t.typeName),
        Number: t.number,
        String: t.string,
        type: t.keyword,
        separator: t.separator,
        comma: t.separator,
        [parentheses]: t.paren,
        [braces]: t.brace,
        [angleBrackets]: t.angleBracket,
        [punctuations]: t.punctuation
      })
    ]
  }),
  languageData: {
    commentTokens: { line: "#" },
    closeBrackets: { brackets: ["{", "<", "[", "(", '"'] },
    indentOnInput: /^\s*(\{|\})$/
  }
});
function liveblocksSchema() {
  return new LanguageSupport(LiveblocksSchema);
}
export {
  LiveblocksSchema,
  linter,
  liveblocksSchema
};
